<?php
/********************************************************/
function wp_migration_yuzu_exchange_dirurl($dirs)
/********************************************************/
{
	if(strpos($dirs,'https://')===false && strpos($dirs,'http://')===false ){
		return( site_url().'/'.str_replace(ABSPATH,'',$dirs) );
	}else{
		$ABS_PATH = rtrim(ABSPATH, '/');
		return( $ABS_PATH.str_replace(site_url(),'',$dirs) );
	}
}
/********************************************************/
function wp_migration_yuzu_dir2url($dirs)
/********************************************************/
{
	if(strpos($dirs,'https://')===false && strpos($dirs,'http://')===false ){
		return( site_url().'/'.str_replace(ABSPATH,'',$dirs) );
	}else{
		return($dirs);
	}
}
/********************************************************/
function wp_migration_yuzu_url2dir($urls)
/********************************************************/
{
	//
	// ߂URL̖ / Ӑ}IɏĂȂ_ɒӁB/ ́AtɕԂ
	//
	if(strpos($urls,'https://')===false && strpos($urls,'http://')===false ){
		return( $urls );
	}else{
		$ABS_PATH = rtrim($_SERVER['DOCUMENT_ROOT'], '/').'/';
		$ABS_URLS = $_SERVER['HTTP_X_FORWARDED_PROTO'].'://'.$_SERVER['HTTP_HOST'];
		$urls = str_replace($ABS_URLS,'',$urls);
		if(substr($urls,0,1)=='/'){
			$urls = substr($urls,1);
		}
		$urls = $ABS_PATH.$urls;
		return( $urls );
	}
}
/********************************************************/
function wp_migration_yuzu_makeFileName($export_path)
/********************************************************/
{
	date_default_timezone_set('Asia/Tokyo');
	$filename = home_url();
	$filename = str_replace('http://' ,'',$filename);
	$filename = str_replace('https://','',$filename);
	$filename = str_replace('/'       ,'_',$filename);
	$filename = str_replace('.'       ,'-',$filename);
	$filename .= '_migration';
	$filename .= '_'.date('Ymd');
	$filename .= '_'.date('His');

	$no = 0;
	$file = $filename;
	while(file_exists($export_path.$file)){
		$file = $filename.'_'.$no;
		$no++;
	}
	return($file);
}


/********************************************************/
function wp_migration_yuzu_toDataTimeConv($v,$t='d')
/********************************************************/
{
	if(     $t=='d'){
		return( substr($v,0,4).'/'.substr($v,4,2).'/'.substr($v,6) );
	}elseif($t=='t'){
		return( substr($v,0,2).':'.substr($v,3,2).':'.substr($v,4) );
	}
	return($v);
}
/********************************************************/
function wp_migration_yuzu_edit_config($wppath,$db_info)
/********************************************************/
{
	$keywd = array(
		'DB_NAME'    =>$db_info['dbname'],
		'DB_USER'    =>$db_info['dbuser'],
		'DB_PASSWORD'=>$db_info['dbpass'],
		'DB_HOST'    =>$db_info['dbhost'],
	);
	$wlines = array();
	$file = rtrim($wppath,'/').'/'.'wp-config.php';
	if(file_exists($file)){
		$buff = '';
		$lines = file($file);
		foreach ($lines as $line) {
			$line = trim($line);
			foreach($keywd as $k => $v){
				$p0 = strpos($line,"define(");
				$p1 = strpos($line,$k);
				if($p0===false || $p1===false){
				}else{
					$line = "define( '".$k."', '".$v."' );";
					break;
				}
			}
			$p = strpos($line,'$table_prefix');
			if($p===false){
			}else{
				$line = "\$table_prefix = '".$db_info['dbpref']."';";
			}
			$wlines[] = $line;
		}
		$fp = fopen($file, 'w');
		foreach($wlines as $line){
			$line = trim($line);
			fwrite($fp, $line."\n");
		}
		fclose($fp);
		return("success");
	}
	return("err:".$file." undef.");
}
/********************************************************/
function wp_migration_yuzu_MySQLtable($php_v,$cmd)
/********************************************************/
{

	global $table_prefix;
	global $wpdb;
	$db_name = DB_NAME;				//f[^x[X̎擾
	$db_user = DB_USER;				//f[^x[Xڑ[U[̎擾
	$db_pass = DB_PASSWORD;			//f[^x[XڑppX[h̎擾
	$db_host = DB_HOST;				//f[^x[XzXg̎擾
	$db_pfix = $table_prefix;		//f[^x[XzXg̎擾
	
	$link = mysqli_connect($db_host, $db_user, $db_pass,$db_name);
	if (!$link) {
		return('');
	}
	$stack = array();
	// f[^
	if($cmd == 'tablelist' || $cmd == 'tabledelete'){
		$sql = "SHOW ";
		$sql.= "TABLES ";
		$sql.= ";";
		if( $result = mysqli_query($link, $sql) ){
			while ($row = $result->fetch_row()) {
				if(substr($row[0],0,strlen($db_pfix))==$db_pfix ){
					// e[uꗗ
					$stack[] = $row[0];
					
					// Se[u폜
					if( $cmd == 'tabledelete' ){
						$sql = "DROP ";
						$sql.= "TABLE ";
						$sql.= $row[0];
						$sql.= ";";
						if( $resultA = mysqli_query($link, $sql) ){
							echo 'del query='.$sql.'<br />';
						}
					}
				}
			}
		}
	}
	mysqli_close($link);
	return($stack);
}
/********************************************************/
function wp_migration_yuzu_MySQLpluginis($cmd='active_plugins')
/********************************************************/
{
	global $table_prefix;
	global $wpdb;
	$db_name = DB_NAME;		//f[^x[X̎擾
	$db_user = DB_USER;		//f[^x[Xڑ[U[̎擾
	$db_pass = DB_PASSWORD;	//f[^x[XڑppX[h̎擾
	$db_host = DB_HOST;		//f[^x[XzXg̎擾
	$db_pfix = $table_prefix;		//f[^x[XzXg̎擾
	
	$link = mysqli_connect($db_host, $db_user, $db_pass,$db_name);
	if (!$link) {
		return('');
	}
	// 
	// ꕔ̃vOC𖳌ɂ́AvOC(PATHt)
	// active plugins  n ԖڂB̃vOC̍sB
	// ["option_value"]=>
	//	a:6:{
	//		i:0;s:57:"all-in-one-wp-migration-4g/all-in-one-wp-migration-4g.php";
	//		i:1;s:33:"classic-editor/classic-editor.php";
	//		i:2;s:35:"classic-widgets/classic-widgets.php";
	//		i:3;s:41:"dashboardmemo_yuzu/dashboardmemo_yuzu.php";
	//		i:4;s:39:"wp_migration_yuzu/wp_migration_yuzu.php";
	//		i:5;s:39:"wp_uninstall_yuzu/wp_uninstall_yuzu.php";
	//	}"
	//
	// 
	$stack = array();
	// f[^
	if($cmd == 'active_plugins'){
		$sql = "SELECT ";
		$sql.= "* ";
		$sql.= "FROM ";
		$sql.= $db_pfix."options ";
		$sql.= "WHERE ";
		$sql.= "option_name = 'active_plugins'";
		$sql.= ";";
		if( $rows = mysqli_query($link, $sql) ){
			foreach($rows as $row){
				$value = maybe_unserialize( $row['option_value'] );
				foreach($value as $val){
					$stack[] = $val;
				}
			}
		}
	}
	mysqli_close($link);
	return($stack);
}
/********************************************************/
function wp_migration_yuzu_temppath_delete($export_path,$igno='')
/********************************************************/
{
	$arcFiles = array();
	$dir = $export_path;
	if( is_dir($dir) ){
		if( $dh = opendir($dir) ){
			while( ($file=readdir($dh))!==false ){
				if($file!=='.' && $file!=='..' ){
					$f = $dir.$file;
					if($igno!=''){
						if( is_dir($f) ){
							wp_migration_yuzu_rmdir($f);
						}
					}else{
						$attrs = wp_migration_yuzu_fileparm($file);	// domain_migration_yyyymmdd_hhmmss_no.zip
						if(count($attrs)>=3){
							if( is_dir($f) ){
								$ymd = wp_migration_yuzu_toDataTimeConv($attrs[1],'d');
								$hms = wp_migration_yuzu_toDataTimeConv($attrs[2],'t');
								$rr = wp_migration_yuzu_filedev($ymd,$hms,'n');
								if($rr>=0.05){
									wp_migration_yuzu_rmdir($f);
								}
							}else{
								$arcFiles = $dir.'<>'.$file.'<>'.$dir.$file.'<>';
							}
						}
					}
				}
			}
			closedir($dh);
		}
	}
	return($arcFiles);
}
/********************************************************/
function wp_migration_yuzu_rmdir($dir)
/********************************************************/
{
	$files = array_diff(scandir($dir), array('.','..'));
	foreach ($files as $file) {
		if (is_dir("$dir/$file")) {
			wp_migration_yuzu_rmdir("$dir/$file");
		}else{
			unlink("$dir/$file");
		}
	}
    return rmdir($dir);
}
/********************************************************/
function wp_migration_yuzu_copy_dir($fr_path, $to_path)
/********************************************************/
{
	$fr_path = rtrim($fr_path, '/').'/';
	$to_path = rtrim($to_path, '/').'/';
	
	if (is_dir($fr_path)) {
		if (!is_dir($to_path)) {
			mkdir($to_path, 0755);
			chmod($to_path, 0755);
		}
		if ($handle = opendir($fr_path)) {
			while (false !== ($file = readdir($handle))) {
				if ($file === '.' || $file === '..') {
					continue;
				}
				if (is_dir($fr_path.$file)) {
					wp_migration_yuzu_copy_dir($fr_path.$file, $to_path.$file);
				} else {
					copy($fr_path.$file, $to_path.$file);
				}
			}
			closedir($handle);
		}
	}
	return('success');
}
/********************************************************/
function wp_migration_yuzu_fnsplit($file)
/********************************************************/
{
	//
	// $fnsplit = wp_migration_yuzu_fnsplit($zipfile);
	// $dir = $fnsplit['dir'];
	// $fil = $fnsplit['fil'];
	// $ext = $fnsplit['ext'];
	// $fnm = $fnsplit['fnm'];
	//
	$result = array();
	$filepath = pathinfo($file);							// /home/example/www/file.txt	|	https://example/file.txt
	$result['dir']=rtrim($filepath['dirname'],'/').'/';		// /home/example/www/			|	https://example/
	$result['fil']=$filepath['filename'];					// file
	$result['ext']=$filepath['extension'];					// txt
	$result['fnm']=$filepath['basename'];					// file.txt
	return($result);
}
$wp_migration_yuzu_backupWp_stck = array();
/********************************************************/
function wp_migration_yuzu_backupWp_list($zippath)
/********************************************************/
{
	global $wp_migration_yuzu_backupWp_stck;
	$wp_migration_yuzu_backupWp_stck = array();
	wp_migration_yuzu_backupWp_dir($zippath,$zippath);
	return($wp_migration_yuzu_backupWp_stck);
}
/********************************************************/
function wp_migration_yuzu_backupWp_dir($org,$src,$fil='')
/********************************************************/
{
	global $wp_migration_yuzu_backupWp_stck;
	$dir = opendir($src);
	while(false !== ( $file = readdir($dir)) ) {
		if (( $file != '.' ) && ( $file != '..' )) {
			$full  = rtrim($src,'/') . '/' . $file;
			if ( is_dir($full) ) {
				if($file=='wp_migration_yuzu_backup_datas'){
					
				}elseif($file=='tables'){
					wp_migration_yuzu_backupWp_dirTable($full);
					
				}elseif($file=='wp-admin' || $file=='wp-includes' || $file=='wp-content' ){
					wp_migration_yuzu_backupWp_dir($org,$full,$file);
					
				}else{
					$setdir = rtrim(str_replace($org,'',$full),'/').'/';
					$wp_migration_yuzu_backupWp_stck[] = 'dir:'.'<>'.$file.'<>'.$setdir.'<>';
				}
			}
		}
	}
	closedir($dir);
	$setdir = str_replace($org,'',$src);
	$wp_migration_yuzu_backupWp_stck[] = 'dir:'.'<>'.$fil.'<>'.$setdir.'<>';
}
/********************************************************/
function wp_migration_yuzu_backupWp_dirTable($src)
/********************************************************/
{
	global $wp_migration_yuzu_backupWp_stck;
	$dir = opendir($src);
	while(false !== ( $file = readdir($dir)) ) {
		if (( $file != '.' ) && ( $file != '..' )) {
			$full  = $src . '/' . $file;
			if ( is_dir($full) ) {
			}else{
				$wp_migration_yuzu_backupWp_stck[] = 'table:'.'<>'.$file.'<>'.$full.'<>';
			}
		}
	}
	closedir($dir);
}
/********************************************************/
function wp_migration_yuzu_backupWp_info($file)
/********************************************************/
{
	$result = array();
	if(file_exists($file)){
		$fp = fopen($file, "r");
		while( ($line=fgets($fp)) ){
			$line = trim($line);
			if(substr($line,0,5)=='<?php'){
			}elseif(substr($line,0,1)=='<'){
				$smbl = str_replace('>','',str_replace('<','',$line));
				while( ($line=fgets($fp)) ){
					$line = trim($line);
					if($line=='</>'){
						break;
					}
					$buff.=$line."#cr#";
				}
				$result[$smbl] = $buff;
				
			}else{
				$split = '';
				if(strpos($line,':')==false){
					if(strpos($line,':')==false){
						$split = 'F';
					}
				}else{
					$split = ':';
				}
				if($split==''){
				}else{
					$lines = explode($split,$line,2);
					$result[$lines[0]] = $lines[1];
				}
			}
		}
		fclose($fp);
	}
	return($result);
}
/********************************************************/
function wp_migration_yuzu_wp_info($order)
/********************************************************/
{

/**
	// DB INFO
	echo wp_migration_yuzu_wp_info('dbname').'<br />';
	echo wp_migration_yuzu_wp_info('dbuser').'<br />';
	echo wp_migration_yuzu_wp_info('dbpass').'<br />';
	echo wp_migration_yuzu_wp_info('dbhost').'<br />';
	echo wp_migration_yuzu_wp_info('dbprefix').'<br />';
	echo wp_migration_yuzu_wp_info('wpver').'<br />';
**/
	global $wp_version;
	global $table_prefix;
	
	if(      $order=='dbname'){
		return(DB_NAME);
		
	}else if($order=='dbuser'){
		return(DB_USER);
		
	}else if($order=='dbpass'){
		return(DB_PASSWORD);
		
	}else if($order=='dbhost'){
		return(DB_HOST);
	
	}else if($order=='dbprefix'){
		return($table_prefix);

	}else if($order=='wpver'){
		return($wp_version);
	}
}
/********************************************************/
function wp_migration_yuzu_source_filecopy($from_path,$toto_path)
/********************************************************/
{
	$dir = opendir($from_path);
	while(false !== ( $file = readdir($dir)) ) {
		if (( $file != '.' ) && ( $file != '..' )){
			$full = $from_path.$file;
			if ( is_dir($full) ) {
			}else{
				copy( $full , $toto_path.$file );
			}
		}
	}
	closedir($dir);
	return('success');
}
/********************************************************/
function wp_migration_yuzu_source_unzip($zipfile,$toUnzip='')
/********************************************************/
{
	if($toUnzip==''){
		// ȗ : zipt@C̃tH_[/zipt@C/ ɓWJ
		$fnsplit = wp_migration_yuzu_fnsplit($zipfile);
		$toUnzip = $fnsplit['dir'].$fnsplit['fil'].'/';
	}
	if(shell_exec("unzip $zipfile -d $toUnzip") ){
		return('success');
	}
	return( 'err:error unzip('.$zipfile.')' );
}
/********************************************************/
function wp_migration_yuzu_source_zip($path, $zipfile,$parm='')
/********************************************************/
{
	$za = new ZipArchive();
	$za->open($zipfile, ZIPARCHIVE::CREATE);
	wp_migration_yuzu_source_zipSub($za, $path);
	$za->close();
    return('success');
}
/********************************************************/
function wp_migration_yuzu_source_zipSub($za,$src,$parent= '')
/********************************************************/
{
	$dir = opendir($src);
	while(false !== ( $file = readdir($dir)) ) {
		if (( $file != '.' ) && ( $file != '..' )) {
			$local = $parent.$file;
			$full  = $src . '/' . $file;
			if ( is_dir($full) ) {
				$za->addEmptyDir($local);
				wp_migration_yuzu_source_zipSub($za, $full, $local.'/');
			}
			else {
				$za->addFile($full, $local);
			}
		}
	}
	closedir($dir);
}
/********************************************************/
function wp_migration_yuzu_info_save($export_path,$parm)
/********************************************************/
{
	global $wp_version;
	global $table_prefix;
	
	$file = $export_path.'wp_migration_info.php';

	$fp = fopen($file, 'w');
	fwrite($fp, '<?php'."\n");
	fwrite($fp, 'dimain:'.home_url()."\n");
	fwrite($fp, 'phpVer:'.phpversion()."\n");
	fwrite($fp, 'wpVer:'.$wp_version."\n");
	
	//fwrite($fp, 'BASE:'.DB_NAME."\n");
	//fwrite($fp, 'USER:'.DB_USER."\n");
	//fwrite($fp, 'PASS:'.DB_PASSWORD."\n");
	//fwrite($fp, 'HOST:'.DB_HOST."\n");
	fwrite($fp, 'PRFX:'.$table_prefix."\n");

	fwrite($fp, '<TABLE>'."\n");
	$tables = wp_migration_yuzu_MySQLtable($php_v,'tablelist');
	foreach($tables as $tbl){
		fwrite($fp, ' '.$tbl."\n");
	}
	fwrite($fp, '</>'."\n");
	
	$plugins = wp_migration_yuzu_MySQLpluginis('active_plugins');
	fwrite($fp, '<PLUGIN>'."\n");
	if (!empty($plugins)) {
		foreach ($plugins as $plugin) {
			$rows = '';
			$rows .= ' '.$plugin;
		    fwrite($fp,$rows."\n");
		}
	}
	fwrite($fp, '</>'."\n");
	fclose($fp);

	return('success');
}
/********************************************************/
function wp_migration_yuzu_table_sql_save($export_path,$table_name)
/********************************************************/
{
	$path = $export_path.'tables/';
	if(is_dir($path)){
	}else{
		mkdir($path);
	}
	
	$dbHost = wp_migration_yuzu_wp_info('dbhost');
	$dbUser = wp_migration_yuzu_wp_info('dbuser');
	$dbPass = wp_migration_yuzu_wp_info('dbpass');
	$dbName = wp_migration_yuzu_wp_info('dbname');
	$savePath = $path.$table_name.'.sql';
	$command = "mysqldump ".$dbName." --host=".$dbHost." --user=".$dbUser." --password=".$dbPass." -e ".'"'.$table_name.'"'." > ".$savePath;
	exec($command);
	
	return('success');
}
/********************************************************/
function wp_migration_yuzu_table_sql_load($db_info=array(),$db_repl=array())
/********************************************************/
{
	$dbHost = $db_info['dbhost'];
	$dbUser = $db_info['dbuser'];
	$dbPass = $db_info['dbpass'];
	$dbName = $db_info['dbname'];
	$table_name = $db_info['table'];
	$loadPath   = $db_info['sqlfile'];
	if(file_exists($loadPath)){
		$buff = '';
		$sqlLine=array();
		$lines = file($loadPath);
		foreach ($lines as $line) {
			$line = trim($line);
			if( substr($line,0,2)=='--' ||
				substr($line,0,2)=='/*' ){
			}else{
				foreach($db_repl as $repl){
					$line = str_replace($repl[0],$repl[1],$line);
				}
				$buff.=$line;
				if(substr($line,-1,1)==';'){
					$sqlLine[] = $buff;
					$buff='';
				}
			}
		}
		if($buff!=''){
			$sqlLine[] = $buff;
		}
		$db = mysqli_connect($dbHost, $dbUser, $dbPass, $dbName);
		if (!$db) {
			return('err:sql conn error.'.mysqli_error());
		}
		mysqli_set_charset($db,'utf8');
		//wp_migration_yuzu_tracesub('===== sql_loadFILE:'.$loadPath.'=================================');
		foreach($sqlLine as $sql){
			//$sqlv = str_replace('),',"),\n",$sql);
			//wp_migration_yuzu_tracesub('--sql_load:'.$sqlv);
			mysqli_query($db,$sql);
		}
		mysqli_close($db);
		return($sqlLine);
	}else{
		return('err:sql file none.');
	}
}
?>
