<?php
function wp_migration_yuzu_overlay($title='')
{
	$result = <<<EOM
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script>
//# sourceURL=overlay.js
var result_str = '';
var process_stop = 0;
var intervalID;
var gwid_val;
var gstr_val;
var rslt_val;
var view_flag;
var process_number;
var process_i;
var idnt='';
var errstat ='';
var data_result ='';

// ボタンを押した時に動く関数
function interval_func()
{
	// 50msおきにプログレスバーを更新する
	intervalID = setInterval("window_update()", 50);
}
function window_open(title)
{
	var vtil = document.getElementById('window_title');
	$("#window_overlay, #window_overlayWindow, #window_stop").fadeIn();

}
function window_stop()
{
//alert('stop ');
	process_stop = 1;
	gstr_val = 100;
}
function window_close()
{
	$("#window_overlay, #window_overlayWindow, #window_stop").fadeOut();
}
function window_view(text,gval)
{
	var ovly = document.getElementById('window_overlay');
	
	var proc = document.getElementById('window_proc');
	var gage = document.getElementById('window_gage');
	var gwid = document.getElementById('window_gwid');
	var gstr = document.getElementById('window_gstr');
	
	proc.innerHTML = text;
	var gwidth = gage.clientWidth;
	if(gval>=0){
		var gval_w =  Math.trunc(gwidth * (gval/100));
		gwid.style.width = gval_w+"px";
		gstr.innerHTML   = gval+"%";
	}
}
</script>
<style>
#window_close{
	display:none;
	z-index: 998;
}
#window_overlay {
	width: 100%;
	height: 100%;
	position: fixed;
	top: 0;
	left: 0;
	background: rgba(99, 99, 99, 0.3);
	display: none;
	z-index: 998;
}
#window_overlayWindow {
	width: 30%;
	height: 30%;
	margin: 100px auto;
	border: 2px solid #000;
	background-color: #fff;
	text-align: center;
	display: none;
	z-index: 999;
}
#window_stop{
	text-align: center;
	display: none;
	z-index: 999;
}
a.window_stopbutton{
	border:2px solid #f00;
	padding:0.3rem 1rem;
	background:#fff;
	text-decoration:none;
	color:#f00;
	border-radius:  40px;
	line-height: 3;
}
a.window_stopbutton:hover{
	background:#f00;
	color:#fff;
}
</style>
<div id="window_overlay">
	<div id="window_overlayWindow">
		<div id="window_inner">
			<p style="margin:0.5rem 0;"><span id="window_title" style="font-weight:bold;">#TITLE#</span></p>
			<p style="margin:0.5rem 0;"><span id="window_proc">&nbsp;</span></p>
			<div style="display:flex;padding:0 1rem;margin:0.5rem 0;">
				<div id="window_gage" style="width:80%;border:1px solid #ccc;">
					<div id="window_gwid" style="width:0%;background:#00f;">&nbsp;</div>
				</div>
				<div id="window_gstr" style="width:20%;">0%</div>
			</div>
		</div>
		<div id="window_close">
			<input type="button" value="閉じる" OnClick="window_close();">
		</div>
		<div id="window_stop"> <!--style="margin:0.5rem 0;"-->
			<a href="#" class="window_stopbutton" OnClick="window_stop();">STOP</a>
		</div>
	</div>
</div>
EOM;
	$result = str_replace('#TITLE#',$title,$result);
	return($result);
}
?>
