<?php
/********************************************************/
function wp_migration_yuzu_process_script($simbol_code,$append_code,$startname,$boot='',$interrupt=array())
/********************************************************/
{
	$plugin_dir_url = plugin_dir_url(__FILE__);
	
	global $wp_migration_yuzu_debugflag;
	$js = '';
	$js.=<<<EOM
	<script>
	//# sourceURL=$startname.js
	var wp_migration_yuzu_debugvalue = {};
EOM;
	foreach($wp_migration_yuzu_debugflag as $k => $v){
		$js.= "\t\t"."wp_migration_yuzu_debugvalue['".$k."'] = '".$v."';"."\n";
	}
	$js.=<<<EOM
	var datamax;
	var etci;
	var comd = new Array();
	var parm = new Array();
	var vtil = new Array();
	var etci = new Array();

	//----- simbol_code -----
$simbol_code
	//-----/simbol_code -----
	function $startname(initdata)
	{
	//----- append_code -----
$append_code
	//-----/append_code -----
		process_number = 0;
		process_i = 0;
		idnt      = '';
		
		$boot
		
		intervalID = setInterval("wp_migration_yuzu_update()", 50);
	}
	function wp_migration_yuzu_update()
	{
		// window open
		if(     process_number==0){
			process_stop = 0;
			window_open();
			process_number = 1;
			$("#window_close").fadeOut();
			//--- process0 ---
			$interrupt[process0]
			//---/process0 ---
			
		// initial
		}else if(process_number==1){
			view_flag= 0;
			gwid_val = '';
			gstr_val = 0;
			window_view(gwid_val,gstr_val);
			process_i=0;
			process_number = 2;
			//--- process1 ---
			$interrupt[process1]
			//---/process1 ---
		
		// last view
		}else if(process_number==3){
			window_view(gwid_val,gstr_val);
			$("#window_close").fadeIn();
			$("#window_stop").fadeOut();
			process_number = 4;
			//--- process3 ---
			$interrupt[process3]
			//---/process3 ---
			
		// end process
		}else if(process_number==4){
			clearInterval(intervalID);
			//--- process4 ---
			$interrupt[process4]
			//---/process4 ---
			
		// process run
		}else{
			// process_number=2 in loop
			$("#window_stop").fadeIn();	// test

			if(process_stop==1){
				gwid_val = "user stop";
				gstr_val = 100;
				process_number = 3;
				//--- userbreak ---
				$interrupt[userbreak]
				//---/userbreak ---
				
			}else{
				//----------------------------
				// 処理中割り込みは止めておく
				//----------------------------
				clearInterval(intervalID);
				//==============
				// 処理呼び出し
				//==============
				var parcent = Math.trunc((process_i/datamax) * 100);
				gwid_val = vtil[process_i];
				gstr_val = parcent;
				//--- POST_par ---
				$interrupt[POST_par]
				//---/POST_par ---
				
				window_view(gwid_val,gstr_val);
				
				//==============
				// run
				//==============
				errstat = '';
				process_run();
				process_i++;
				//==============
				// debug stop
				//==============
				debug_value = wp_migration_yuzu_debugvalue['EXPORT_PROCESS_MAX_COUNT'];
				if(debug_value!=-1){
					if( process_i>debug_value){
						process_stop=2;		// end
					}
				}
				//==============
				// end check
				//==============
				if(gstr_val>=100 || process_stop>=1 || process_i>=datamax || errstat!=''){
					if(errstat!=''){
						gwid_val = errstat;
						gstr_val = 100;
					}else{
						//
						// process_stop:1 user break
						// process_stop:2 normal end
						// process_stop:3 debug end
						//
						if( process_stop>=1){
						}else{
							gwid_val = '処理終了';
							gstr_val = 100;
						}
					}
					process_number = 3;
				}
				//--- process2 ---
				$interrupt[process2]
				//---/process2 ---
				//----------------------------
				// 割り込み再開
				//----------------------------
				intervalID = setInterval("wp_migration_yuzu_update()", 50);
			}
		}
	}
	function process_run()
	{
		//============
		// debug stop
		//============
		var runflag = 1;
		debug_value = wp_migration_yuzu_debugvalue['EXPORT_PROCESS_STOP_COMMAND'];
		if(debug_value!=-1){
			if( comd[process_i]==debug_value){
				process_stop=3;		// debug 
				runflag = 0;
			}
		}
		//============
		if(runflag == 1){
			//--- POST_before ---
			$interrupt[POST_before]
			//---/POST_before ---
			wp_migration_yuzu_POST(process_i,wppt,comd[process_i],parm[process_i],vtil[process_i],etci[process_i]);
		}
	}
	function wp_migration_yuzu_POST(no,wppath,comd,parm,vtil,etci)
	{
		var url = '';
		url+= '$plugin_dir_url';
		url+= 'wp_migration_yuzu_jointPOST.php';
		$.ajax({
			type: 'POST',
			url: url,
			dataType: 'json',
			async : false,   // ← asyncをfalseに設定する(同期)
			data: {
				wppt : wppath,
				comd : comd,
				idnt : idnt,
				parm : parm,
				vtil : vtil,
				etci : etci,
			},
			beforeSend: function(xhr, settings) {
				// ajax送信前の処理
			},
			complete: function(xhr, status) {
				// ajax応答後の処理
			},
			success: function(data) {
				// ajax通信成功時の処理
				rslt_val = data.result;
				if(data.errstat){
					errstat  = data.errstat;
				}else{
					if(data.result=='command none.'){
						gwid_val = '['+comd+'] '+data.result;
						gstr_val = 100;
						process_stop=2;
					}
					$interrupt[POST_success]
				}
				console.log('comd=' +data.comd + ' idnt=' +data.idnt+ ' parm=' +data.parm + ' result=' + data.result);
			},
			error: function(xhr,status,error){
				// ajax通信成失敗の処理
				console.log("XMLHttpRequest : " + xhr.status);
				console.log("textStatus     : " + status);
				console.log("errorThrown    : " + error.message);
				gwid_val = vtil+' Post Error : '+ error;
				gstr_val = 100;
				process_stop=1;
				$interrupt[POST_error]
			}
		});
	}
	</script>
EOM;
	return($js);
}
?>
